<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
namespace CORE;
/**
 * 	\file       lcr/core/boxes/box_lcr_invoice_waiting.php
 * 	\ingroup    lcr
 * 	\brief      Module to build boxe for events
 */
include_once DOL_DOCUMENT_ROOT . '/core/boxes/modules_boxes.php';

namespace CORE\LCR;

/**
 * Class to manage the box to show last events
 */
class box_lcr_invoice_waiting extends \ModeleBoxes {

    var $boxcode = "lcr_invoice_waiting";
    var $boximg = "object_lcr";
    var $boxlabel = "Box_lcr_invoice_waiting";
    var $depends = array();
    var $db;
    var $param;
    var $info_box_head = array();
    var $info_box_contents = array();
    var $source;

    public  $enabled = true

	, $defaulton =  array(
					'lcr'
				) ; 
								
    public function __construct($db, $param = '') {
				 global $user, $langs,  $conf, $bc;
				 
        //init
        $this->db = $db;
        $this->param = $param;
        parent::__construct($db, $param);
        
        if (empty($conf->lcr->enabled))
					$this->enabled = false;
    }

    /**
     *  Load data for box to show them later
     *
     *  @param	int		$max        Maximum number of records to load
     *  @return	void
     */
    function loadBox($max = 5) {
        global $user, $langs,  $conf;

		dol_include_once('/lcr/class/lignelcr.class.php');
		dol_include_once('/lcr/class/rejetlcr.class.php');
		dol_include_once('/lcr/class/facture.lcr.class.php');
		dol_include_once('/lcr/class/bonlcr.class.php');
		dol_include_once('/lcr/core/lib/lcr.lib.php');

		$db = $this->db; 
		
		$thirdpartystatic=new \Societe($db);
		$invoicestatic=new FactureLcr($db);
		$bprev = new BonLcr($db);
		$var=true;


		/*
		* Invoices waiting for withdraw
		*/
		$sql = "SELECT f.ref as facnumber, f.rowid, pfd.amount,pfd.date_lim_reglement,f.total_ttc, f.fk_statut, f.paye, f.type,";
		$sql.= " pfd.date_demande,";
		$sql.= " s.nom, s.rowid as socid";
		$sql.= " FROM ".MAIN_DB_PREFIX."facture as f,";
		$sql.= " ".MAIN_DB_PREFIX."societe as s";
		if (!$user->rights->societe->client->voir && !$socid) $sql.= ", ".MAIN_DB_PREFIX."societe_commerciaux as sc";
		$sql.= " , ".MAIN_DB_PREFIX."lcr_facture_demande as pfd";
		$sql.= " WHERE s.rowid = f.fk_soc";
		$sql.= " AND f.entity = ".$conf->entity;
		$sql.= " AND pfd.traite = 0 AND pfd.fk_facture = f.rowid";
		if (!$user->rights->societe->client->voir && !$socid) $sql.= " AND s.rowid = sc.fk_soc AND sc.fk_user = " .$user->id;
		if ($socid) $sql.= " AND f.fk_soc = ".$socid;

		$resql=$db->query($sql);
		if ($resql)
		{
			$num = $db->num_rows($resql);
			$i = 0;


			if ($num)
			{
				$output.='<table class="noborder" width="100%">';
				$var = True;
				while ($i < $num && $i < 20)
				{
					$obj = $db->fetch_object($resql);

					$invoicestatic->id=$obj->rowid;
					$invoicestatic->ref=$obj->facnumber;
					$invoicestatic->statut=$obj->fk_statut;
					$invoicestatic->paye=$obj->paye;
					$invoicestatic->type=$obj->type;
					$alreadypayed=$invoicestatic->getSommePaiement();

					$thirdpartystatic->id=$obj->socid;
					$thirdpartystatic->nom=$obj->nom;
					
					$var=!$var;
					$output .= '<tr '.$bc[$var].'>';

					$output .= '<td>'
						.$invoicestatic->getNomUrl(1,'withdrawlcr')
						. '</td>';
					$output .= '<td>'
						.$thirdpartystatic->getNomUrl(1,'customer')
						. '</td>';

					$output .= '<td align="right">';
					$output .= price($obj->amount);
					$output .= '</td>';
					$output .= '<td align="right">/ ';
					$output .= price($obj->total_ttc);
					$output .= '</td>';

					$output .= '<td align="right">';
					$output .= dol_print_date($db->jdate($obj->date_demande),'day');
					$output .= '</td>';
					$output .= '<td align="right">';
					$output .= dol_print_date($db->jdate($obj->date_lim_reglement),'day');
					$output .= '</td>';
					$output .= '<td align="right">';
					$output .= $invoicestatic->getLibStatut(3,$alreadypayed);
					$output .= '</td>';
					$output .= '</tr>';
					$i++;
				}
			}
			else
			{
				$output .= '<tr><td colspan="7">'.$langs->trans("NoInvoiceToWithdraw").'</td></tr>';
			}

			$output.='</table>'; 
		}
		else
		{
			dol_print_error($db);
		}


  
		$this->info_box_contents[0][0] = array(
						'td' => 'align="center" class="nohover"'
					, 'textnoformat' => $output
					);
            
        $this->info_box_head = array(
            'text' => $langs->trans("InvoiceWaitingWithdraw").' ('.$num.')',
//             'limit' => dol_strlen($langs->trans("OrdersToProcess")),
            'graph' => 0,
            'target' => 'none'
        );

    }
    
    

    

    /**
     * 	Method to show box
     *
     * 	@param	array	$head       Array with properties of box title
     * 	@param  array	$contents   Array with properties of box lines
     * 	@return	void
     */
    function showBox($head = null, $contents = null, $nooutput=0) {
        parent::showBox($this->info_box_head, $this->info_box_contents);
    }

}
