<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */
/**
 * 	\file       htdocs/compta/lcr/create_bydate.php
 *  \ingroup    lcr
 * 	\brief      Lcr creation page
 */
/**
  @brief def master namespace
 */

namespace CORE;

/**
  @brief load base of structure
 */
$res = 0;
if (!$res && file_exists("../main.inc.php")) $res = @include("../main.inc.php");
if (!$res && file_exists("../../main.inc.php")) $res = @include("../../main.inc.php");
if (!$res && file_exists("../../../main.inc.php")) $res = @include("../../../main.inc.php");
if (!$res && file_exists("../../../../main.inc.php")) $res = @include("../../../../main.inc.php");
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php"))
        $res = @include("../../../dolibarr/htdocs/main.inc.php");     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php"))
        $res = @include("../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res && file_exists("../../../../../dolibarr/htdocs/main.inc.php"))
        $res = @include("../../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res) die("Include of main fails");



require_once DOL_DOCUMENT_ROOT.'/core/lib/admin.lib.php';
require_once DOL_DOCUMENT_ROOT.'/compta/bank/class/account.class.php';



/**
  @brief Call Specific Class provider for OScssShop Exts
  This class garanted process for dolibarr evolution
 */
dol_include_once('/framework/main.inc.php');
dol_include_once('/framework/core/lib/framework.lib.php');


loadClass("Societe");
loadClass("User");

namespace CORE\FRAMEWORK;

namespace CORE\LCR;

use \Form;
use \User;
use \CORE\FRAMEWORK\Societe;
use \CORE\LCR\FactureLcr;
use \CORE\LCR\BonLcr;

dol_include_once('/lcr/class/bonlcr.class.php');
dol_include_once('/lcr/class/facture.lcr.class.php');
dol_include_once('/lcr/core/lib/lcr.lib.php');




$langs->load("banks");
$langs->load("categories");
$langs->load("widthdrawals");
$langs->load("companies");
$langs->load("bills");
$langs->load("lcr@lcr");

// Security check
if ($user->societe_id) $socid  = $user->societe_id;
$result = restrictedArea($user, 'lcr', '', '', 'bons');

// check config this module
if (lcr_check_config() < 0) {
    $langs->load("errors");
    setEventMessage($langs->trans("ErrorModuleSetupNotComplete"), 'warnings');
}


// Get supervariables
$action = GETPOST('action', 'alpha');


/**
  @brief instancisation des class utilisé dans cette page
 */
$thirdpartystatic = new Societe($db);
$invoicestatic    = new FactureLcr($db);
$bprev            = new BonLcr($db);



/*
 * Actions
 */


if ($action == 'create') {


    if (!empty($_REQUEST["date_lim_reglement"]))
            $result = $bprev->create(GETPOST("LCR_ID_BANKACCOUNT"), GETPOST("mode"), 'real',
            $_REQUEST["date_lim_reglement"]);
    else $result = $bprev->create(GETPOST("LCR_ID_BANKACCOUNT"), GETPOST("mode"));

    if ($result < 0) setEventMessages($bprev->error, $bprev->errors, 'errors');

    elseif ($result == 0) setEventMessage($langs->trans("NoInvoiceCouldBeWithdrawed"), 'warnings');



    if ($bprev->id > 0) {
        header('location: '.dol_buildpath('/lcr/fiche.php?id='.$bprev->id, 1));
        exit;
    }
}


/*
 * View
 */



llxHeader('', $langs->trans("NewStandingOrder"));


$h           = 0;
$head[$h][0] = dol_buildpath('/lcr/create.php', 1);
$head[$h][1] = $langs->trans("NewStandingOrder");
$h++;

dol_fiche_head($head, $hselected, $langs->trans("StandingOrders")." LCR", 0, 'payment');


$nbdate        = $bprev->NbFactureAPreleverdate();
$factures_date = $bprev->FactureAPreleverdate();

$pricetowithdrawdate = $bprev->SommeAPreleverdate();
$nb                  = $bprev->NbFactureAPrelever();
$nb1                 = $bprev->NbFactureAPrelever(1);
$nb11                = $bprev->NbFactureAPrelever(1, 1);
$pricetowithdraw     = $bprev->SommeAPrelever();
if ($nb < 0 || $nb1 < 0 || $nb11 < 0) {
    dol_print_error($bprev->error);
}
print '<table class="border" width="100%">';

print '<tr><td>'.$langs->trans("NbOfInvoiceToWithdraw").'</td>';
print '<td align="right">';
print $nb;
print '</td></tr>';

print '<tr><td>'.$langs->trans("InvoiceToWithdraw").'</td>';
print '<td align="right">';
$fact = new FactureLcr($db);
foreach ($factures_date as $id_fact) {
    $fact->fetch($id_fact);
    print $fact->getNomURL(3);
}
print '</td></tr>';

print '<tr><td>'.$langs->trans("AmountToWithdraw").'</td>';
print '<td align="right"><b>';
print price($pricetowithdraw, 0, $langs, 0, 2, 2, $conf->currency);
print '</b></td>';
print '</tr>';


print '</table>';

if ($mesg) print $mesg;

print "<div class=\"tabsAction\">\n";
$form = new Form($db);
if ($nb) {
    print '<form method="GET" action="create_bydate.php">';
    print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
    print $langs->trans("TypeOfLcr").":";
    print '<select name="mode"><option value="3">'.$langs->trans('LcrImmediat').'</option><option value="1">'.$langs->trans('LcrEscompte').'</option></select> ';
    print $langs->trans("BankToReceiveWithdraw").":";
    print $form->select_comptes($conf->global->LCR_ID_BANKACCOUNT, 'LCR_ID_BANKACCOUNT', 0, "courant=1", 1);
    if ($pricetowithdraw)
            print '<button type="submit" class="butAction" name="action" value="create">'.$langs->trans("CreateAll")."</button>\n";
    else print '<a class="butActionRefused" href="#">'.$langs->trans("CreateAll")."</a>\n";
    print '</form>';
}
else {
    print '<a class="butActionRefused" href="#" title="'.dol_escape_htmltag($langs->transnoentitiesnoconv("NoInvoiceToWithdraw")).'">'.$langs->trans("CreateAll")."</a>\n";
}
//if ($nb11) print '<a class="butAction" href="create_bydate.php?action=create&amp;banque=1">'.$langs->trans("CreateBanque")."</a>\n";
//if ($nb1)  print '<a class="butAction" href="create_bydate.php?action=create&amp;banque=1&amp;guichet=1">'.$langs->trans("CreateGuichet")."</a>\n";

print "</div>\n";
print '<br />';
if (!empty($nbdate)) {
    foreach ($nbdate as $date_lim_reglement => $nb) {
        print '<table class="border" width="100%">';

        print '<tr><td>'.$langs->trans("NbOfInvoiceToWithdraw").' '.date("d/m/Y", strtotime($date_lim_reglement)).'</td>';
        print '<td align="right">';
        print $nb;
        print '</td></tr>';

        print '<tr><td>'.$langs->trans("InvoiceToWithdraw").'</td>';
        print '<td align="right">';
        $factures_date = $bprev->listFacture($date_lim_reglement);
        $fact = new FactureLcr($db);
        foreach ($factures_date as $id_fact) {
            $fact->fetch($id_fact);
            print $fact->getNomURL(3).' ';
        }
        print '</td></tr>';

        print '<tr><td>'.$langs->trans("AmountToWithdraw").'</td>';
        print '<td align="right"><b>';
        print price($pricetowithdrawdate[$date_lim_reglement], 0, $langs, 0, 2, 2, $conf->currency);
        print '</b></td>';
        print '</tr>';

        //print '<tr><td>'.$langs->trans("NbOfInvoiceToWithdraw").' + '.$langs->trans("ThirdPartyBankCode").'='.$conf->global->LCR_CODE_BANQUE.'</td><td align="right">';
        //print $nb1;
        //print '</td></tr>';
        //print '<tr><td>'.$langs->trans("NbOfInvoiceToWithdrawWithInfo").'</td><td align="right">';
        //print $nb11;
        //print '</td></tr>';

        print '</table>';


        //if ($mesg) print $mesg;

        print "<div class=\"tabsAction\">\n";

        if ($nb) {
            print '<form method="GET" action="create_bydate.php">';
            print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
            print '<input type="hidden" name="date_lim_reglement" value="'.$date_lim_reglement.'">';
            print $langs->trans("TypeOfLcr").":";
            print '<select name="mode"><option value="3">'.$langs->trans('LcrImmediat').'</option><option value="1">'.$langs->trans('LcrEscompte').'</option></select> ';

            print $langs->trans("BankToReceiveWithdraw").":";
            print $form->select_comptes($conf->global->LCR_ID_BANKACCOUNT, 'LCR_ID_BANKACCOUNT', 0, "courant=1", 1);
            if ($pricetowithdrawdate[$date_lim_reglement])
                    print '<button type="submit" class="butAction" name="action" value="create">'.$langs->trans("CreateAll").' '.date("d/m/Y",
                        strtotime($date_lim_reglement))."</button>\n";
            else print '<a class="butActionRefused" href="#">'.$langs->trans("CreateAll")."</a>\n";
            print '</form>';
        }
        else {

            print '<a class="butActionRefused" href="#" title="'.dol_escape_htmltag($langs->transnoentitiesnoconv("NoInvoiceToWithdraw")).'">'.$langs->trans("CreateAll")."</a>\n";
        }
        //if ($nb11) print '<a class="butAction" href="create_bydate.php?action=create&amp;banque=1">'.$langs->trans("CreateBanque")."</a>\n";
        //if ($nb1)  print '<a class="butAction" href="create_bydate.php?action=create&amp;banque=1&amp;guichet=1">'.$langs->trans("CreateGuichet")."</a>\n";

        print "</div>\n";
        print '<br>';
    }
}
print '</div>';
/*
 * Invoices waiting for withdraw
 */

$sql = "SELECT f.ref as facnumber, f.rowid, f.total_ttc,pfd.amount,pfd.date_lim_reglement, s.nom, s.rowid as socid,";
$sql .= " pfd.date_demande, pfd.mode, fp.preconfirm ";
$sql .= " FROM ".MAIN_DB_PREFIX."facture f";
$sql .= " LEFT JOIN ".MAIN_DB_PREFIX."societe s ON s.rowid = f.fk_soc";
$sql .= " LEFT JOIN ".MAIN_DB_PREFIX."lcr_facture_demande pfd ON f.rowid = pfd.fk_facture";
$sql .= " LEFT JOIN ".MAIN_DB_PREFIX."lcr_facture_preconfirm fp ON f.rowid = fp.fk_facture";
$sql .= " WHERE f.entity = ".$conf->entity;
$sql .= " AND pfd.traite = 0";



$resql = $db->query($sql);
if ($resql) {
    $num = $db->num_rows($resql);
    $i   = 0;

    print_fiche_titre($langs->trans("InvoiceWaitingWithdraw").($num > 0 ? ' ('.$num.')' : ''), '', '');

    print '<table class="noborder" width="100%">';
    print '<tr class="liste_titre">';
    print '<td>'.$langs->trans("Invoice").'</td>';
    print '<td>'.$langs->trans("ThirdParty").'</td>';
    print '<td align="right">'.$langs->trans("LcrMode").'</td>';
    print '<td align="right">'.$langs->trans("Amount").'</td>';
    print '<td align="right">'.$langs->trans("TotalTTC").'</td>';
    print '<td align="right">'.$langs->trans("DateRequest").'</td>';
    print '<td align="right">'.$langs->trans("DateMaxPayment").'</td>';
    print '</tr>';

    if ($num) {
        $var = True;
        while ($i < $num && $i < 20) {
            $obj                   = $db->fetch_object($resql);
            $var                   = !$var;
            print '<tr '.$bc[$var].' '.(!empty($conf->global->LCR_MODE_PRECONFIRM) && $obj->preconfirm != 1 ? 'style="background:red;"'
                        : '').'><td>';
            $invoicestatic->id     = $obj->rowid;
            $invoicestatic->ref    = $obj->facnumber;
            print $invoicestatic->getNomUrl(1, 'withdrawlcr');
            print ' <a href="'.dol_buildpath('/lcr/tab/lcr.php?facid='.$obj->rowid, 1).'">';
            print img_edit($langs->trans('EditLCR'), false);
            print '</a></td>';
            print '<td>';
            $thirdpartystatic->id  = $obj->socid;
            $thirdpartystatic->nom = $obj->nom;
            print $thirdpartystatic->getNomUrl(1, 'customer');
            print '</td>';

            print '<td align="right">';
            print ( ($obj->mode > 0) ? $langs->trans('LcrEscompte') : $langs->trans('LcrImmediat'));
            print '</td>';

            print '<td align="right">';
            print price($obj->amount, 0, $langs, 0, 2, -1, $conf->currency);
            print '</td>';
            print '<td align="right"> ';
            print price($obj->total_ttc, 0, $langs, 0, 2, -1, $conf->currency);
            print '</td>';
            // Date
            print '<td align="right">';
            print dol_print_date($db->jdate($obj->date_demande), 'day');

            print '</td>';
            print '<td align="right">';
            print dol_print_date($db->jdate($obj->date_lim_reglement), 'day');
            print '</td>';
            print '</tr>';
            $i++;
        }
    } else print '<tr><td colspan="7">'.$langs->trans("None").'</td></tr>';
    print "</table>";
    print "<br>\n";
}
else {
    dol_print_error($db);
}

$db->close();

llxFooter();
