<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

/**
 *	\file       htdocs/compta/lcr/fiche.php
 *	\ingroup    lcr
 *	\brief      Fiche lcr
 */
namespace CORE;


$res = 0;
if (!$res && file_exists("../main.inc.php"))
    $res = @include("../main.inc.php");
if (!$res && file_exists("../../main.inc.php"))
    $res = @include("../../main.inc.php");
if (!$res && file_exists("../../../main.inc.php"))
    $res = @include("../../../main.inc.php");
if (!$res && file_exists("../../../../main.inc.php"))
    $res = @include("../../../../main.inc.php");
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../dolibarr/htdocs/main.inc.php");     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res && file_exists("../../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res)
    die("Include of main fails");


require_once DOL_DOCUMENT_ROOT.'/compta/bank/class/account.class.php';



/**
	@brief Call Specific Class provider for OScssShop Exts 
		This class garanted process for dolibarr evolution 
*/
dol_include_once('/framework/main.inc.php');
dol_include_once('/framework/core/lib/framework.lib.php');
    
    
loadClass("Societe");
loadClass("User");

    
namespace CORE\FRAMEWORK;

namespace CORE\LCR;


use \CORE\LCR\BonLcr;
use \User;
use \Form;


dol_include_once('/lcr/class/bonlcr.class.php');
// dol_include_once('/lcr/class/lignelcr.class.php');
dol_include_once('/lcr/core/lib/lcr.lib.php');

dol_include_once('/compta/paiement/class/paiement.class.php');


$langs->load("banks");
$langs->load("categories");

if (!$user->rights->lcr->bons->lire)
accessforbidden();

$langs->load("bills");
$langs->load("withdrawals");


// Security check
if ($user->societe_id > 0) accessforbidden();

// Get supervariables
$action = GETPOST('action','alpha');
$id = GETPOST('id','int');


$object = new BonLcr($db,"");
$muser = new User($db);

if ($id > 0)
	$object->fetch($id);

/*
 * Actions
 */
 
switch($action){

	case 'confirm_delete':
		if ($object->delete() > 0){
			setEventMessage($langs->trans("LcrOkDeleteBon"),'mesgs');
			$location=dol_buildpath('/lcr/fiche.php?id='.$id,1);
		}else {
			setEventMessage($langs->trans("LcrErrorInDelProcess"),'errors');
			$location=dol_buildpath('/lcr/fiche.php?id='.$id,1);
		}
		
		header('location: '.dol_buildpath('/lcr/create.php',1) );
		exit;
	break; 
	
	case 'confirm_credite':
		if (  GETPOST('confirm','alpha') == 'yes'){

			$object->set_credite();

			header('location: '.dol_buildpath('/lcr/fiche.php?id='.$id,1) );
			exit;
		}
	break; 
	
	case 'infotrans':
		if ( $user->rights->lcr->bons->send){
			require_once DOL_DOCUMENT_ROOT.'/core/lib/files.lib.php';


			$dt = dol_mktime(12,0,0,GETPOST('remonth','int'),GETPOST('reday','int'),GETPOST('reyear','int'));

			$error = $object->set_infotrans($user, $dt, GETPOST('methode','alpha'));

			if ($error)
			{
				setEventMessage($object->ReadError($error),'errors');
			}
			header('location: '.dol_buildpath('/lcr/fiche.php?id='.$id,1) );
			exit;
		}
	break; 
	
	case 'infocredit':
		if ( $user->rights->lcr->bons->credit){
			$dt = dol_mktime(12,0,0,GETPOST('remonth','int'),GETPOST('reday','int'),GETPOST('reyear','int'));

			$error = $object->set_infocredit($user, $dt);

			if ($error)
			{
				setEventMessage($object->ReadError($error,'errors'));

			}
			header('location: '.dol_buildpath('/lcr/fiche.php?id='.$id,1) );
			exit;
		}
	break; 
	
	default:
}









/*
 * View
 */


$form = new Form($db);

llxHeader('',$langs->trans("WithdrawalReceipts"));

	$head = lcr_prepare_head($object);
	
	print PrintHeadCardTab('lcr', $object, $id); 

	if (empty($object->date_trans) && $user->rights->lcr->bons->send && $action=='settransmitted')
	{
		print '<form method="post" name="userfile" action="fiche.php?id='.$object->id.'" enctype="multipart/form-data">';
		print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
		print '<input type="hidden" name="action" value="infotrans">';
		print '<table class="border" width="100%">';
		print '<tr class="liste_titre">';
		print '<td colspan="3">'.$langs->trans("NotifyTransmision").'</td></tr>';
		print '<tr><td width="20%">'.$langs->trans("TransData").'</td><td>';
		print $form->select_date('','','','','',"userfile",1,1);
		print '</td></tr>';
		print '<tr><td width="20%">'.$langs->trans("TransMetod").'</td><td>';
		print $form->selectarray("methode",$object->methodes_trans);
		print '</td></tr>';
/*			print '<tr><td width="20%">'.$langs->trans("File").'</td><td>';
		print '<input type="hidden" name="max_file_size" value="'.$conf->maxfilesize.'">';
		print '<input class="flat" type="file" name="userfile"><br>';
		print '</td></tr>';*/
		print '</table><br>';
		print '<center><input type="submit" class="button" value="'.dol_escape_htmltag($langs->trans("SetToStatusSent")).'">';
		print '</form>';
	}

	if (! empty($object->date_trans) && $object->date_credit == 0 && $user->rights->lcr->bons->credit && $action=='setcredited')
	{
		print '<form name="infocredit" method="post" action="fiche.php?id='.$object->id.'">';
		print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
		print '<input type="hidden" name="action" value="infocredit">';
		print '<table class="border" width="100%">';
		print '<tr class="liste_titre">';
		print '<td colspan="3">'.$langs->trans("NotifyCredit").'</td></tr>';
		print '<tr><td width="20%">'.$langs->trans('CreditDate').'</td><td>';
		print $form->select_date('','','','','',"infocredit",1,1);
		print '</td></tr>';
		print '</table>';
		print '<br>'.$langs->trans("ThisWillAlsoAddPaymentOnInvoice");
		print '<center><input type="submit" class="button" value="'.dol_escape_htmltag($langs->trans("ClassCredited")).'">';
		print '</form>';
	}



	
	// Actions
	if ($action != 'settransmitted' && $action != 'setcredited')
	{
		print "\n<div class=\"tabsAction\">\n";

		if (empty($object->date_trans) && $user->rights->lcr->bons->send)
		{
			print "<a class=\"butAction\" href=\"fiche.php?action=settransmitted&id=".$object->id."\">".$langs->trans("SetToStatusSent")."</a>";
		}

		if (! empty($object->date_trans) && $object->date_credit == 0)
		{
			print "<a class=\"butAction\" href=\"fiche.php?action=setcredited&id=".$object->id."\">".$langs->trans("ClassCredited")."</a>";
		}

		
		
		if($object->statut <= 1 )
		print "<a class=\"butActionDelete\" href=\"fiche.php?action=confirm_delete&id=".$object->id."\">".$langs->trans("Delete")."</a>";

		print "</div>";
	}



llxFooter();

$db->close();
