<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

/**
 * 		\file       htdocs/compta/lcr/fiche-rejet.php
 *      \ingroup    lcr
 *		\brief      Withdraw reject
 */
namespace CORE;


$res = 0;
// if (!$res && file_exists("../main.inc.php"))
//     $res = @include("../main.inc.php");
if (!$res && file_exists("../../main.inc.php"))
    $res = @include("../../main.inc.php");
if (!$res && file_exists("../../../main.inc.php"))
    $res = @include("../../../main.inc.php");
if (!$res && file_exists("../../../../main.inc.php"))
    $res = @include("../../../../main.inc.php");
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../dolibarr/htdocs/main.inc.php");     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res && file_exists("../../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res)
    die("Include of main fails");
    
// require_once DOL_DOCUMENT_ROOT.'/core/lib/lcr.lib.php';
// require_once DOL_DOCUMENT_ROOT.'/compta/lcr/class/bonlcr.class.php';
// require_once DOL_DOCUMENT_ROOT.'/compta/lcr/class/rejetlcr.class.php';
require_once DOL_DOCUMENT_ROOT.'/compta/paiement/class/paiement.class.php';
require_once DOL_DOCUMENT_ROOT.'/compta/bank/class/account.class.php';




/**
	@brief Call Specific Class provider for OScssShop Exts 
		This class garanted process for dolibarr evolution 
*/
dol_include_once('/framework/main.inc.php');
dol_include_once('/framework/core/lib/framework.lib.php');
    
    
namespace CORE\FRAMEWORK;

namespace CORE\LCR;
use \User;

use \CORE\LCR\FactureLcr;
// use \CORE\LCR\BonLcr;
use \CORE\LCR\LigneLcr;
use \CORE\FRAMEWORK\Societe;

dol_include_once('/lcr/class/facture.lcr.class.php');
dol_include_once('/lcr/class/bonlcr.class.php');
dol_include_once('/lcr/class/lignelcr.class.php');
dol_include_once('/lcr/class/rejetlcr.class.php');

loadClass("Societe");
loadClass("User");


dol_include_once('/lcr/core/lib/lcr.lib.php');



$langs->load("banks");
$langs->load("categories");
$langs->load('withdrawals');
$langs->load('bills');

// Securite acces client
if ($user->societe_id > 0) accessforbidden();

// Get supervariables
$prev_id = GETPOST('id','int');
$page = GETPOST('page','int');




// $StaticBon=new BonLcr($db,"");
$StaticLigne = new LigneLcr($db, $user);
$StaticFactureLcr =new FactureLcr($db);
$StaticSociete =new Societe($db);


/*
 * View
 */
llxHeader('',$langs->trans("WithdrawalReceipts"));

if ($prev_id)
{
  	$bon = new BonLcr($db,"");

		print PrintHeadCardTab('rejects', $bon, $prev_id); 
}

$rej = new RejetLcr($db, $user);

/*
 * Liste des factures
 */
$sql = "SELECT pl.rowid as rowid_ligne, pl.amount, pl.statut as statut_ligne";
$sql.= " , s.rowid as socid, s.nom";
$sql.= " , pr.motif, pr.afacturer as facnumber, pr.fk_facture as facid";
$sql.= " FROM ".MAIN_DB_PREFIX."lcr_bons as p";
$sql.= " , ".MAIN_DB_PREFIX."lcr_lignes as pl";
$sql.= " , ".MAIN_DB_PREFIX."societe as s";
$sql.= " , ".MAIN_DB_PREFIX."lcr_rejet as pr";
$sql.= " WHERE p.rowid=".$prev_id;
$sql.= " AND pl.fk_lcr_bons = p.rowid";
$sql.= " AND p.entity = ".$conf->entity;
$sql.= " AND pl.fk_soc = s.rowid";
$sql.= " AND pl.statut = 3 ";
$sql.= " AND pr.fk_lcr_lignes = pl.rowid";
if ($socid) $sql.= " AND s.rowid = ".$socid;
$sql.= " ORDER BY pl.amount DESC";

$resql = $db->query($sql);
if ($resql)
{
 	 $num = $db->num_rows($resql);
  	$i = 0;

  	print "\n<!-- debut table -->\n";
  	print '<table class="noborder" width="100%" cellspacing="0" cellpadding="4">';
  	print '<tr class="liste_titre">';
  	print '<td>'.$langs->trans("Line").'</td><td>'.$langs->trans("ThirdParty").'</td><td align="right">'.$langs->trans("Amount").'</td>';
  	print '<td>'.$langs->trans("Reason").'</td><td align="center">'.$langs->trans("ToBill").'</td><td align="center">'.$langs->trans("Invoice").'</td></tr>';

  	$var=True;
	$total = 0;

	while ($i < $num)
    {
		$obj = $db->fetch_object($resql);

		$StaticLigne->id = $obj->rowid_ligne;
		$StaticLigne->statut = $obj->statut_ligne;
		$StaticLigne->ref = substr('000000'.$obj->rowid_ligne, -6);
		
	
		$StaticFactureLcr->id = $obj->facid ; 
		$StaticFactureLcr->ref = $obj->facnumber ; 

		$StaticSociete->id = $obj->socid; 
		$StaticSociete->nom = $obj->nom; 
				
				
		print "<tr $bc[$var]>";
				
				print '<td>'
							.$StaticLigne->getNomUrl(1,16)
							.'</td>';
				print '<td>'
							.$StaticSociete->getNomUrl(1,16)
							.'</td>';
							
				print '<td align="right">'.price($obj->amount)."</td>\n";
				print '<td>'.$rej->motifs[$obj->motif].'</td>';

				print '<td align="center">'.yn($obj->afacturer).'</td>';
		
			print '<td>'
						.( ($obj->facid > 0)?$StaticFactureLcr->getNomUrl(1,16) : '' )
						.'</td>';

		print "</tr>\n";

		$total += $obj->amount;
		$var=!$var;
		$i++;
	}

	print '<tr class="liste_total"><td>&nbsp;</td>';
	print '<td class="liste_total">'.$langs->trans("Total").'</td>';
	print '<td align="right">'.price($total)."</td>\n";
	print '<td colspan="3">&nbsp;</td>';
	print "</tr>\n</table>\n";
	$db->free($resql);
}
else
{
	dol_print_error($db);
}

$db->close();

llxFooter();
