<?php
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

/**
 *	\file       htdocs/compta/facture/lcr.php
 *	\ingroup    facture
 *	\brief      Gestion des lcr d'une facture
 */
namespace CORE;

$res = 0;
// if (!$res && file_exists("../main.inc.php"))
//     $res = @include("../main.inc.php");
if (!$res && file_exists("../../main.inc.php"))
    $res = @include("../../main.inc.php");
if (!$res && file_exists("../../../main.inc.php"))
    $res = @include("../../../main.inc.php");
if (!$res && file_exists("../../../../main.inc.php"))
    $res = @include("../../../../main.inc.php");
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../dolibarr/htdocs/main.inc.php");     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res && file_exists("../../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res)
    die("Include of main fails");


require_once DOL_DOCUMENT_ROOT.'/core/lib/invoice.lib.php';
require_once DOL_DOCUMENT_ROOT.'/core/class/discount.class.php';
require_once DOL_DOCUMENT_ROOT.'/societe/class/companybankaccount.class.php';
require_once DOL_DOCUMENT_ROOT.'/core/class/extrafields.class.php';

dol_include_once('/core/class/extrafields.class.php');
dol_include_once('/societe/class/societe.lcr.class.php');

/**
 *	@brief Call Specific Class provider for OScssShop Exts
 *		This class garanted process for dolibarr evolution
 */
dol_include_once('/framework/main.inc.php');
dol_include_once('/framework/core/lib/framework.lib.php');


namespace CORE\FRAMEWORK;

namespace CORE\LCR;

use \CORE\LCR\FactureLcr;
use \Form;
use \discount;
use \DiscountAbsolute;
use \CORE\LCR\LigneLcr;
use \CompanyBankAccount;
use \User;
use \Societe;
use \ExtraFields;

dol_include_once('/lcr/class/facture.lcr.class.php');
dol_include_once('/lcr/class/bonlcr.class.php');
dol_include_once('/lcr/class/lignelcr.class.php');

dol_include_once('/lcr/core/lib/lcr.lib.php');


/// Translations
$langs->loadLangs(array("banks", "bills", "withdrawals", "lcr@lcr"));


// GET/POST Clean
$id = (GETPOST('id', 'int') ? GETPOST('id', 'int') : GETPOST('facid', 'int'));  // For backward compatibility
$ref = GETPOST('ref', 'alpha');
$socid = GETPOST('socid', 'int');
$action = GETPOST('action', 'alpha');

$fieldid = (!empty($ref) ? 'facnumber' : 'rowid');

// other vars 
$errornonew = 0;


// right control 
if (!$user->rights->facture->lire)
	accessforbidden();
if ($user->societe_id)
	$socid = $user->societe_id;

$result = restrictedArea($user, 'facture', $id, '', '', 'fk_soc', $fieldid);


// Instanciate all classes
$StaticUser = new User($db);
$StaticBonLcr = new BonLcr($db);
$StaticLigne = new LigneLcr($db, $user);

$account = new CompanyBankAccount($db);

$object = new FactureLcr($db);


// Load object
if ($id > 0 || !empty($ref)) {
	$ret = $object->fetch($id, $ref);
	if ($ret > 0)
		$object->fetch_thirdparty();

	// 		$extrafields = new ExtraFields($db);
	// 		$extralabels=$extrafields->fetch_name_optionals_label($object->table_element);
	// 
	// 		$object->fetch_optionals($object->id,$extralabels);


	$societe = new Societe($db);
	$societe->fetch($object->socid);
	$extrafields = new ExtraFields($db);
	$extralabels = $extrafields->fetch_name_optionals_label($societe->table_element);

	$societe->fetch_optionals($object->socid, $extralabels);
}


// 	$societe->array_options['options_lcr_auto']
// var_dump(); 
// exit;


// Check if rib exists for this societe
$account->fetch(0, $object->thirdparty->id);
if ($account->default_rib <= 0) {
	setEventMessage($langs->trans("ErrorNoRibForThisSociete"), 'errors');
	$errornonew = 1;
}


/*
 * Actions
 */
switch ($action) {
	case 'new':

		if ($object->id > 0) {
			$object->date_lim_reglement = dol_mktime(12, 0, 0, $_POST['remonth'], $_POST['reday'], $_POST['reyear']);

			$result = $object->demande_lcr($user, GETPOST('withdraw_request_amount'), (GETPOST('type') == "escompte" ? 1 : 0));
			if ($result > 0) {
				if (array_key_exists('options_' . $conf->global->LCR_MODE_PRECONFIRM_EXTRA_COMPANY, $societe->array_options) && (int) $societe->array_options['options_' . $conf->global->LCR_MODE_PRECONFIRM_EXTRA_COMPANY] == 1) {
					$result = $object->preconfirm_confirm(1);
				}

				header("Location: " . $_SERVER['PHP_SELF'] . "?id=" . $object->id);
				exit;
			} else {
				setEventMessage($object->error, 'errors');
			}
		}

		break;

	case 'delete':

		if ($object->id > 0) {
			$result = $object->demande_lcr_delete($user, GETPOST('did'));
			if ($result == 0) {
				header("Location: " . $_SERVER['PHP_SELF'] . "?id=" . $object->id);
				exit;
			}
		}

		break;

	case 'preconfirm':
		// 	var_dump(__file__); 

		if ($object->id > 0) {
			$result = $object->preconfirm_confirm(1, GETPOST('preconfirmdate', 'alpha'));
			//var_dump($result);
			if ($result == 0) {
				header("Location: " . $_SERVER['PHP_SELF'] . "?id=" . $object->id);
				exit;
			}
		}
		break;
}

/*
 * View
 */

$now = dol_now();


llxHeader('', $langs->trans("Bill"));

$form = new Form($db);

global $conf;


// var_dump(LCR_MODE_PRECONFIRM_EXTRA_COMPANY); 
// 
// exit; 

/* *************************************************************************** */
/*                                                                             */
/* Mode fiche                                                                  */
/*                                                                             */
/* *************************************************************************** */

if ($object->id > 0) {
	$totalpaye  = $object->getSommePaiement();
	$totalcreditnotes = $object->getSumCreditNotesUsed();
	$totaldeposits = $object->getSumDepositsUsed();

	// We can also use bcadd to avoid pb with floating points
	// For example print 239.2 - 229.3 - 9.9; does not return 0.
	//$resteapayer=bcadd($object->total_ttc,$totalpaye,$conf->global->MAIN_MAX_DECIMALS_TOT);
	//$resteapayer=bcadd($resteapayer,$totalavoir,$conf->global->MAIN_MAX_DECIMALS_TOT);
	$resteapayer = price2num($object->total_ttc - $totalpaye - $totalcreditnotes - $totaldeposits, 'MT');

	if ($object->paye) $resteapayer = 0;
	$resteapayeraffiche = $resteapayer;

	$absolute_discount = $object->thirdparty->getAvailableDiscounts('', 'fk_facture_source IS NULL');
	$absolute_creditnote = $object->thirdparty->getAvailableDiscounts('', 'fk_facture_source IS NOT NULL');
	$absolute_discount = price2num($absolute_discount, 'MT');
	$absolute_creditnote = price2num($absolute_creditnote, 'MT');

	$author = new User($db);
	if ($object->user_author) {
		$author->fetch($object->user_author);
	}

	$head = facture_prepare_head($object);

	dol_fiche_head($head, 'lcrtab', $langs->trans('InvoiceCustomer'), 0, 'bill');

	/*
	 *   Facture
	*/
	print '<table class="border" width="100%">';

	$linkback = '<a href="' . DOL_URL_ROOT . '/compta/facture/list.php' . (!empty($socid) ? '?socid=' . $socid : '') . '">' . $langs->trans("BackToList") . '</a>';

	// Ref
	print '<tr><td width="20%">' . $langs->trans("Ref") . '</td><td colspan="5">';
	$morehtmlref = '';
	$discount = new DiscountAbsolute($db);
	$result = $discount->fetch(0, $object->id);
	if ($result > 0) {
		$morehtmlref = ' (' . $langs->trans("CreditNoteConvertedIntoDiscount", $discount->getNomUrl(1, 'discount')) . ')';
	}
	if ($result < 0) {
		dol_print_error('', $discount->error);
	}
	print $form->showrefnav($object, 'ref', $linkback, 1, 'facnumber', 'ref', $morehtmlref);
	print "</td></tr>";

	// Ref customer
	print '<tr><td width="20%">';
	print '<table class="nobordernopadding" width="100%"><tr><td>';
	print $langs->trans('RefCustomer');
	print '</td>';
	print '</tr></table>';
	print '</td>';
	print '<td colspan="5">';
	print $object->ref_client;
	print '</td></tr>';

	// Third party
	print '<tr><td>' . $langs->trans('Company') . '</td>';
	print '<td colspan="5">' . $object->thirdparty->getNomUrl(1, 'compta');
	print ' &nbsp; (<a href="' . DOL_URL_ROOT . '/compta/facture/list.php?socid=' . $object->socid . '">' . $langs->trans('OtherBills') . '</a>)</td>';
	print '</tr>';

	// Type
	print '<tr><td>' . $langs->trans('Type') . '</td><td colspan="5">';
	print $object->getLibType();
	if ($object->type == 1) {
		$facreplaced = new Facture($db);
		$facreplaced->fetch($object->fk_facture_source);
		print ' (' . $langs->transnoentities("ReplaceInvoice", $facreplaced->getNomUrl(1)) . ')';
	}
	if ($object->type == 2) {
		$facusing = new Facture($db);
		$facusing->fetch($object->fk_facture_source);
		print ' (' . $langs->transnoentities("CorrectInvoice", $facusing->getNomUrl(1)) . ')';
	}

	$facidavoir = $object->getListIdAvoirFromInvoice();
	if (count($facidavoir) > 0) {
		print ' (' . $langs->transnoentities("InvoiceHasAvoir");
		$i = 0;
		foreach ($facidavoir as $id) {
			if ($i == 0) print ' ';
			else print ',';
			$facavoir = new Facture($db);
			$facavoir->fetch($id);
			print $facavoir->getNomUrl(1);
		}
		print ')';
	}
	/*
	if ($facidnext > 0)
	{
		$facthatreplace=new Facture($db);
		$facthatreplace->fetch($facidnext);
		print ' ('.$langs->transnoentities("ReplacedByInvoice",$facthatreplace->getNomUrl(1)).')';
	}
	*/
	print '</td></tr>';

	// Discounts
	print '<tr><td>' . $langs->trans('Discounts') . '</td><td colspan="5">';
	if ($object->thirdparty->remise_percent) print $langs->trans("CompanyHasRelativeDiscount", $object->thirdparty->remise_percent);
	else print $langs->trans("CompanyHasNoRelativeDiscount");
	print '. ';
	if ($absolute_discount > 0) {
		if ($object->statut > 0 || $object->type == 2 || $object->type == 3) {
			if ($object->statut == 0) {
				print $langs->trans("CompanyHasAbsoluteDiscount", price($absolute_discount), $langs->transnoentities("Currency" . $conf->currency)) . '. ';
			} else {
				if ($object->statut < 1 || $object->type == 2 || $object->type == 3) {
					$text = $langs->trans("CompanyHasAbsoluteDiscount", price($absolute_discount), $langs->transnoentities("Currency" . $conf->currency));
					print '<br>' . $text . '.<br>';
				} else {
					$text = $langs->trans("CompanyHasAbsoluteDiscount", price($absolute_discount), $langs->transnoentities("Currency" . $conf->currency));
					$text2 = $langs->trans("AbsoluteDiscountUse");
					print $form->textwithpicto($text, $text2);
				}
			}
		} else {
			// Remise dispo de type non avoir
			$filter = 'fk_facture_source IS NULL';
			print '<br>';
			$form->form_remise_dispo($_SERVER["PHP_SELF"] . '?id=' . $object->id, 0, 'remise_id', $object->thirdparty->id, $absolute_discount, $filter, $resteapayer);
		}
	}
	if ($absolute_creditnote > 0) {
		// If validated, we show link "add credit note to payment"
		if ($object->statut != 1 || $object->type == 2 || $object->type == 3) {
			if ($object->statut == 0 && $object->type != 3) {
				$text = $langs->trans("CompanyHasCreditNote", price($absolute_creditnote), $langs->transnoentities("Currency" . $conf->currency));
				print $form->textwithpicto($text, $langs->trans("CreditNoteDepositUse"));
			} else print $langs->trans("CompanyHasCreditNote", price($absolute_creditnote), $langs->transnoentities("Currency" . $conf->currency)) . '.';
		} else {
			// Remise dispo de type avoir
			$filter = 'fk_facture_source IS NOT NULL';
			if (!$absolute_discount) print '<br>';
			$form->form_remise_dispo($_SERVER["PHP_SELF"] . '?id=' . $object->id, 0, 'remise_id_for_payment', $object->thirdparty->id, $absolute_creditnote, $filter, $resteapayer);
		}
	}
	if (!$absolute_discount && !$absolute_creditnote) print $langs->trans("CompanyHasNoAbsoluteDiscount") . '.';
	print '</td></tr>';

	// Date invoice
	print '<tr><td>';
	print '<table class="nobordernopadding" width="100%"><tr><td>';
	print $langs->trans('Date');
	print '</td>';
	if ($object->type != 2 && $action != 'editinvoicedate' && !empty($object->brouillon) && $user->rights->facture->creer) print '<td align="right"><a href="' . $_SERVER["PHP_SELF"] . '?action=editinvoicedate&amp;id=' . $object->id . '">' . img_edit($langs->trans('SetDate'), 1) . '</a></td>';
	print '</tr></table>';
	print '</td><td colspan="3">';

	if ($object->type != 2) {
		if ($action == 'editinvoicedate') {
			$form->form_date($_SERVER['PHP_SELF'] . '?id=' . $object->id, $object->date, 'invoicedate');
		} else {
			print dol_print_date($object->date, 'daytext');
		}
	} else {
		print dol_print_date($object->date, 'daytext');
	}
	print '</td>';
	print '</tr>';

	// Date payment term
	print '<tr><td>';
	print '<table class="nobordernopadding" width="100%"><tr><td>';
	print $langs->trans('DateMaxPayment');
	print '</td>';
	if ($object->type != 2 && $action != 'editpaymentterm' &&  !empty($object->brouillon) && $user->rights->facture->creer
	) print '<td align="right"><a href="' . $_SERVER["PHP_SELF"] . '?action=editpaymentterm&amp;id=' . $object->id . '">' . img_edit($langs->trans('SetDate'), 1) . '</a></td>';
	print '</tr></table>';
	print '</td><td colspan="3">';
	if ($object->type != 2) {
		if ($action == 'editpaymentterm') {
			$form->form_date($_SERVER['PHP_SELF'] . '?id=' . $object->id, $object->date_lim_reglement, 'paymentterm');
		} else {
			print dol_print_date($object->date_lim_reglement, 'daytext');
			if ($object->date_lim_reglement < ($now - $conf->facture->client->warning_delay) && !$object->paye && $object->statut == 1 && !isset($object->am)) print img_warning($langs->trans('Late'));
		}
	} else {
		print '&nbsp;';
	}
	print '</td></tr>';

	// Conditions de reglement
	print '<tr><td>';
	print '<table class="nobordernopadding" width="100%"><tr><td>';
	print $langs->trans('PaymentConditionsShort');
	print '</td>';
	if ($object->type != 2 && $action != 'editconditions' && !empty($object->brouillon) && $user->rights->facture->creer) print '<td align="right"><a href="' . $_SERVER["PHP_SELF"] . '?action=editconditions&amp;id=' . $object->id . '">' . img_edit($langs->trans('SetConditions'), 1) . '</a></td>';
	print '</tr></table>';
	print '</td><td colspan="3">';
	if ($object->type != 2) {
		if ($action == 'editconditions') {
			$form->form_conditions_reglement($_SERVER['PHP_SELF'] . '?id=' . $object->id, $object->cond_reglement_id, 'cond_reglement_id');
		} else {
			$form->form_conditions_reglement($_SERVER['PHP_SELF'] . '?id=' . $object->id, $object->cond_reglement_id, 'none');
		}
	} else {
		print '&nbsp;';
	}
	print '</td></tr>';

	// Mode de reglement
	print '<tr><td>';
	print '<table class="nobordernopadding" width="100%"><tr><td>';
	print $langs->trans('PaymentMode');
	print '</td>';
	if ($action != 'editmode' && !empty($object->brouillon) && $user->rights->facture->creer) print '<td align="right"><a href="' . $_SERVER["PHP_SELF"] . '?action=editmode&amp;id=' . $object->id . '">' . img_edit($langs->trans('SetMode'), 1) . '</a></td>';
	print '</tr></table>';
	print '</td><td colspan="3">';
	if ($action == 'editmode') {
		$form->form_modes_reglement($_SERVER['PHP_SELF'] . '?id=' . $object->id, $object->mode_reglement_id, 'mode_reglement_id');
	} else {
		$form->form_modes_reglement($_SERVER['PHP_SELF'] . '?id=' . $object->id, $object->mode_reglement_id, 'none');
	}
	print '</td></tr>';

	// Montants
	print '<tr><td>' . $langs->trans('AmountHT') . '</td>';
	print '<td align="right" colspan="2" nowrap>' . price($object->total_ht) . '</td>';
	print '<td>' . $langs->trans('Currency' . $conf->currency) . '</td></tr>';
	print '<tr><td>' . $langs->trans('AmountVAT') . '</td><td align="right" colspan="2" nowrap>' . price($object->total_tva) . '</td>';
	print '<td>' . $langs->trans('Currency' . $conf->currency) . '</td></tr>';

	// Amount Local Taxes
	if ($mysoc->country_code == 'ES') {
		if ($mysoc->localtax1_assuj == "1") //Localtax1 RE
		{
			print '<tr><td>' . $langs->transcountry("AmountLT1", $mysoc->country_code) . '</td>';
			print '<td align="right" colspan="2" nowrap>' . price($object->total_localtax1) . '</td>';
			print '<td>' . $langs->trans("Currency" . $conf->currency) . '</td></tr>';
		}
		if ($mysoc->localtax2_assuj == "1") //Localtax2 IRPF
		{
			print '<tr><td>' . $langs->transcountry("AmountLT2", $mysoc->country_code) . '</td>';
			print '<td align="right" colspan="2" nowrap>' . price($object->total_localtax2) . '</td>';
			print '<td>' . $langs->trans("Currency" . $conf->currency) . '</td></tr>';
		}
	}

	print '<tr><td>' . $langs->trans('AmountTTC') . '</td><td align="right" colspan="2" nowrap>' . price($object->total_ttc) . '</td>';
	print '<td>' . $langs->trans('Currency' . $conf->currency) . '</td></tr>';

	// We can also use bcadd to avoid pb with floating points
	// For example print 239.2 - 229.3 - 9.9; does not return 0.
	//$resteapayer=bcadd($object->total_ttc,$totalpaye,$conf->global->MAIN_MAX_DECIMALS_TOT);
	//$resteapayer=bcadd($resteapayer,$totalavoir,$conf->global->MAIN_MAX_DECIMALS_TOT);
	$resteapayer = price2num($object->total_ttc - $totalpaye - $totalcreditnotes - $totaldeposits, 'MT');
	//     $totalFacture  = $resteapayer;


	print '<tr><td>' . $langs->trans('RemainderToPay') . '</td><td align="right" colspan="2" nowrap>' . price($resteapayer) . '</td>';
	print '<td>' . $langs->trans('Currency' . $conf->currency) . '</td></tr>';

	// Statut
	print '<tr><td>' . $langs->trans('Status') . '</td>';
	print '<td align="left" colspan="3">' . ($object->getLibStatut(4, $totalpaye)) . '</td></tr>';

	print '<tr><td>' . $langs->trans("RIB") . '</td><td colspan="5">';
	print $object->thirdparty->display_rib();
	print '</td></tr>';

	// 	$editable= true;
	// Option Control pre-confirmation chauqe facture doit etre accepte par le client avant
	// d'obtenir la possiblité de faire une demande de prelevement
	if (isset($conf->global->LCR_MODE_PRECONFIRM) && (int)$conf->global->LCR_MODE_PRECONFIRM == 1) {
		if (isset($conf->global->LCR_MODE_PRECONFIRM_EXTRA_COMPANY) && !empty($conf->global->LCR_MODE_PRECONFIRM_EXTRA_COMPANY)) {
			if (array_key_exists('options_' . $conf->global->LCR_MODE_PRECONFIRM_EXTRA_COMPANY, $societe->array_options) &&  (int)$societe->array_options['options_' . $conf->global->LCR_MODE_PRECONFIRM_EXTRA_COMPANY] == 0) {

				if ($object->preconfirm == 1) {
					print '<tr><td  colspan="6">' . $langs->trans("LcrLastConfirmed", dol_print_date($object->preconfirm_date)) . '</td></tr>';
				} else {
					// 					$errornonew++;
					print '<form method="POST" action="">';
					print '<input type="hidden" name="id" value="' . $object->id . '" />';
					print '<input type="hidden" name="action" value="preconfirm" />';
					print '<tr rowspan="2"><td  colspan="6">' . $langs->trans("LcrAlertConfirmPrevUse") . '</td></tr>';
					print '<tr><td>' . $langs->trans("LcrConfirmPrevUse") . '</td><td colspan="5">';
					print '<input type="checkbox" name="preconfirm" value="1" style="display:none;" checked />';

					$form->selectDate(time(), 'preconfirmdate', 0, 0, 1, 'preconfirmdate');

					print '<input type="submit" name="preconfirmbt" class="butAction" value="' . $langs->trans('ConfirmedByClient') . '" />';
					print '</td></tr>';

					print '</form>';
				}
			}
		}
	}

	print '</table>';

	dol_fiche_end();


	/*
	 * Withdrawal request
	 */


	// Calculate reste a payer, sur la base des demandes non mise en bon
	$sql = "SELECT pfd.rowid, pfd.traite, pfd.date_demande as date_demande,pfd.date_lim_reglement";
	$sql .= " , pfd.date_traite as date_traite";
	$sql .= " , pfd.amount";
	$sql .= " , u.rowid as user_id, u.lastname, u.firstname, u.login";
	$sql .= " FROM " . MAIN_DB_PREFIX . "lcr_facture_demande as pfd";
	$sql .= " , " . MAIN_DB_PREFIX . "user as u";
	$sql .= " WHERE fk_facture = '" . $object->id . "' ";
	$sql .= " AND pfd.fk_user_demande = u.rowid";
	$sql .= " AND pfd.entity='" . $conf->entity . "'";
	$sql .= " AND pfd.traite = 0 ";
	$sql .= " ORDER BY pfd.date_demande DESC";

	$result_sql = $db->query($sql);
	if ($result_sql) {
		$num = $db->num_rows($result_sql);
		$i = 0;
		while ($i < $num) {
			$var = !$var;
			$objr = $db->fetch_object($result_sql);
			$i++;
			$resteapayer -= $objr->amount;
		}
	}

	// calculate reste a payer deja en bon mais bon a statut 0
	$sql = "SELECT pfd.rowid, pfd.traite, pfd.date_demande,pfd.date_lim_reglement,";
	$sql .= " pfd.date_traite, pfd.fk_lcr_bons, pfd.amount,";
	$sql .= " pb.ref, pb.statut, ";
	$sql .= " u.rowid as user_id, u.lastname, u.firstname, u.login";
	$sql .= " FROM " . MAIN_DB_PREFIX . "lcr_facture_demande as pfd,";
	$sql .= " " . MAIN_DB_PREFIX . "lcr_bons as pb,";
	$sql .= " " . MAIN_DB_PREFIX . "user as u";
	$sql .= " WHERE fk_facture = " . $object->id;
	$sql .= " AND pfd.fk_user_demande = u.rowid";
	$sql .= " AND pb.rowid = pfd.fk_lcr_bons";
	$sql .= " AND pfd.entity='" . $conf->entity . "'";
	$sql .= " AND pfd.traite = 1";
	$sql .= " AND pb.statut < 2 ";
	$sql .= " ORDER BY pfd.date_demande DESC";
	$result_sql = $db->query($sql);
	if ($result_sql) {
		$num = $db->num_rows($result_sql);
		$i = 0;
		while ($i < $num) {
			$var = !$var;
			$objr = $db->fetch_object($result_sql);
			$i++;
			$resteapayer -= $objr->amount;
		}
	}


	/*
	 * Buttons
	 */

	print "\n<div class=\"tabsAction\">\n";

	// Add a withdraw request
	if ($object->statut > 0  &&  $object->statut < 2 && $object->paye == 0 /*&& $num == 0*/ && $resteapayer >= 0) {
		if ($user->rights->lcr->bons->creer && !$errornonew && $resteapayer != 0) {
			print '<form method="POST" action="">';
			print '<input type="hidden" name="id" value="' . $object->id . '" />';
			print '<input type="hidden" name="action" value="new" />';
			print '<label for="withdraw_request_amount">' . $langs->trans('WithdrawRequestAmount') . ' </label>';

			print ' <select id="autofill_amount"><option value="' . $resteapayer . '">' . $langs->trans('LeftToPay') . '</option>';
			for ($i = 2; $i < 11; $i++) {
				print '<option value="' . round($object->total_ttc / $i, 2) . '">1/' . $i . '</option>';
			}
			print '</select><script>';
			print '$("select#autofill_amount").change(function(){
                    $("input#withdraw_request_amount").val($(this).val());
                });';
			print '</script>';

			print ' <input type="text" id="withdraw_request_amount" name="withdraw_request_amount" value="' . $resteapayer . '" size="10" />';

			print ' <select name="type">';
			print '<option value="comptant">Comptant</option>';
			print '<option value="escompte">A l\'escompte</option>';
			print '</select>';


			if (!isset($_POST['remonth'])) {
				$d = dol_print_date($object->date_lim_reglement, 'day');
				$_POST['remonth'] = substr($d, 3, 2);
				$_POST['reday'] = substr($d, 0, 2);
				$_POST['reyear'] = substr($d, 6, 4);
			}

			$datef = dol_mktime(12, 0, 0, $_POST['remonth'], $_POST['reday'], $_POST['reyear']);

			print $form->selectDate($datef, '', '', '', '', "add", 1, 1, 1);

			print '<input type="submit" class="butAction" value="' . $langs->trans("MakeWithdrawRequest") . '" />';
			print '</form>';
		} else {
			print '<a class="butActionRefused" href="#">' . $langs->trans("MakeWithdrawRequest") . '</a>';
		}
	} else {
		print '<a class="butActionRefused" href="#">' . $langs->trans("MakeWithdrawRequest") . '</a>';
	}

	print "</div><br>\n";


	print $langs->trans("DoStandingOrdersBeforePayments") . " LCR" . '<br><br>';

	print '<table class="noborder" width="100%">';

	print '<tr class="liste_titre">';

	print '<td align="left">' . $langs->trans("DateRequest") . '</td>';
	print '<td align="center">' . $langs->trans("DateMaxPayment") . '</td>';
	print '<td align="center">' . $langs->trans("DateProcess") . '</td>';
	print '<td align="center">' . $langs->trans("Amount") . '</td>';
	print '<td align="center">' . $langs->trans("WithdrawalReceipt") . '</td>';
	print '<td align="center">' . $langs->trans("User") . '</td><td>&nbsp;</td><td>&nbsp;</td>';
	print '</tr>';
	$var = True;


	$sql = "SELECT pfd.rowid, pfd.traite, pfd.date_demande as date_demande,pfd.date_lim_reglement";
	$sql .= " , pfd.date_traite as date_traite";
	$sql .= " , pfd.amount";
	$sql .= " , u.rowid as user_id, u.lastname, u.firstname, u.login";
	$sql .= " FROM " . MAIN_DB_PREFIX . "lcr_facture_demande as pfd";
	$sql .= " , " . MAIN_DB_PREFIX . "user as u";
	$sql .= " WHERE fk_facture = " . $object->id;
	$sql .= " AND pfd.fk_user_demande = u.rowid";
	$sql .= " AND pfd.entity='" . $conf->entity . "'";
	$sql .= " AND pfd.traite = 0";
	$sql .= " ORDER BY pfd.date_demande DESC";

	$result_sql = $db->query($sql);
	if ($result_sql) {
		$num = $db->num_rows($result_sql);
	}

	/*
	 * Withdrawals
	 */

	if ($result_sql) {
		$i = 0;

		while ($i < $num) {
			$obj = $db->fetch_object($result_sql);
			$var = !$var;

			$StaticUser->id = $obj->user_id;
			$StaticUser->nom = $obj->login;

			print "<tr " . $bc[$var] . ">";
			print '<td align="left">' . dol_print_date($db->jdate($obj->date_demande), 'day') . "</td>\n";
			print '<td align="center">' . dol_print_date($db->jdate($obj->date_lim_reglement), 'day') . "</td>\n";
			print '<td align="center">' . $langs->trans("OrderWaiting") . '</td>';
			print '<td align="center">' . price($obj->amount) . '</td>';
			print '<td align="center">-</td>';
			print '<td align="center">'
			. $StaticUser->getNomUrl(1, 16)
			. "</td>\n";
			print '<td>&nbsp;</td>';
			print '<td>';
			print '<a href="' . $_SERVER['PHP_SELF'] . '?id=' . $object->id . '&amp;action=delete&amp;did=' . $obj->rowid . '">';
			print img_delete();
			print '</a></td>';
			print "</tr>\n";
			$i++;
		}

		$db->free($result_sql);
	} else {
		dol_print_error($db);
	}

	$sql = "SELECT pfd.rowid, pfd.traite, pfd.date_demande,pfd.date_lim_reglement,";
	$sql .= " pfd.date_traite, pfd.fk_lcr_bons, pfd.amount,";
	$sql .= " pb.ref, pb.statut, ";
	$sql .= " u.rowid as user_id, u.lastname, u.firstname, u.login";
	$sql .= " FROM " . MAIN_DB_PREFIX . "lcr_facture_demande as pfd,";
	$sql .= " " . MAIN_DB_PREFIX . "lcr_bons as pb,";
	$sql .= " " . MAIN_DB_PREFIX . "user as u";
	$sql .= " WHERE fk_facture = " . $object->id;
	$sql .= " AND pfd.fk_user_demande = u.rowid";
	$sql .= " AND pb.rowid = pfd.fk_lcr_bons";
	$sql .= " AND pfd.entity='" . $conf->entity . "'";
	$sql .= " AND pfd.traite = 1";
	$sql .= " ORDER BY pfd.date_demande DESC";

	$result = $db->query($sql);
	if ($result) {
		$num = $db->num_rows($result);
		$i = 0;

		while ($i < $num) {
			$obj = $db->fetch_object($result);
			$var = !$var;

			$StaticBonLcr->id = $obj->fk_lcr_bons;
			$StaticBonLcr->ref = $obj->ref;
			$StaticBonLcr->statut = $obj->statut;


			// 			$StaticLigne->id=$obj->fk_lcr_bons;
			// 			$StaticLigne->ref=$obj->ref;
			// 			$StaticLigne->statut=$obj->statut;

			$StaticUser->id = $obj->user_id;
			$StaticUser->nom = $obj->login;


			print "<tr " . $bc[$var] . ">";

			print '<td align="left">' . dol_print_date($db->jdate($obj->date_demande), 'day') . "</td>\n";
			print '<td align="center">' . dol_print_date($db->jdate($obj->date_lim_reglement), 'day') . "</td>\n";

			print '<td align="center">' . dol_print_date($db->jdate($obj->date_traite), 'day') . "</td>\n";

			print '<td align="center">' . price($obj->amount) . '</td>';

			// 			print '<td align="center">'
			// 			.$StaticLigne->getNomUrl(1,16)
			// 			."</td>\n";
			// 				
			print '<td align="center">'
				. $StaticBonLcr->getNomUrl(1, 16)
				. "</td>\n";

			print '<td align="center">'
				. $StaticUser->getNomUrl(1, 16)
				. "</td>\n";

			print '<td>&nbsp;</td>';
			print '<td>&nbsp;</td>';

			print "</tr>\n";
			$i++;
		}

		$db->free($result);
	} else {
		dol_print_error($db);
	}

	print "</table>";
}


llxFooter();
$db->close();
